



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ5262(容斥)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ5262(容斥)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 07:56:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div><strong>题目描述</strong></div>
<div>听着自己美妙的曲子，小Z进入了梦乡。在梦中，小Z仿佛又回到了自己纵横考场的年代。在梦中，小Z参加了一场</div>
<div>考试，这场考试一共有n道题，每道题的最终得分都是一个大于等于0的整数。然而醒来后，小Z忘记了自己每道题</div>
<div>的得分。他只记得自己计算过m次一些题目的分数和，每道题都被计算过，并且只被计算过一次。除此之外他还记</div>
<div>得其中t道题的满分分别是多少（一道题的得分不会超过满分）。现在小Z想知道他这场考试有多少种得分情况（至</div>
<div>少有一道题的得分不同就算不同的情况），因为这个答案可能很大，你只需要输出答案对1,000,000,007取模后的</div>
<div>结果即可。</div>
<div><strong>题解</strong></div>
<div>看到t比较小，就想到容斥。</div>
<div>我是把每一次求和分开算，最后乘起来，每次找出这次求和的所有限制，然后就2^n枚举限制的选择情况，用C(n+m-1,m-1)算方案数。</div>
<div><strong>代码</strong></div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;vector&gt;<br />
#define N 2000009<br />
using namespace std;<br />
typedef long long ll;<br />
const int maxn=;<br />
vector&lt;ll&gt;vec[N];<br />
ll jie[N],ni[N],ans,k[N],sum[N],n,m,p[N],t,num[N];<br />
const int mod=1e9+;<br />
inline int rd(){<br />
    int x=;char c=getchar();bool f=;<br />
    while(!isdigit(c)){if(c=='-')f=;c=getchar();}<br />
    while(isdigit(c)){x=(x&lt;&lt;)+(x&lt;&lt;)+(c^);c=getchar();}<br />
    return f?-x:x;<br />
}<br />
inline ll power(ll x,int y){<br />
    ll ans=;<br />
    while(y){if(y&amp;)ans=ans*x%mod;x=x*x%mod;y&gt;&gt;=;}<br />
    return ans;<br />
}<br />
inline ll C(int x,int y){if(x&lt;y)return ;return jie[x]*ni[y]%mod*ni[x-y]%mod;}<br />
void dfs(int s,int i,int num,int k,int q,ll sum){<br />
    if(i&gt;k){<br />
        if(s&amp;)ans-=C(sum-num+q-,q-);<br />
        else ans+=C(sum-num+q-,q-);<br />
        ans=(ans%mod+mod)%mod;<br />
        return;<br />
    }<br />
    dfs(s+,i+,num+p[i]+,k,q,sum);dfs(s,i+,num,k,q,sum);<br />
}<br />
int main(){<br />
//    freopen("Equation.in","r",stdin);<br />
//    freopen("Equation.out","w",stdout);<br />
    n=rd();m=rd();int x,y;<br />
    jie[]=;for(int i=;i&lt;=maxn;++i)jie[i]=jie[i-]*i%mod;ni[maxn]=power(jie[maxn],mod-);<br />
    for(int i=maxn-;i&gt;=;--i)ni[i]=ni[i+]*(i+)%mod;<br />
    for(int i=;i&lt;=m;++i){<br />
        k[i]=rd();<br />
        for(int j=;j&lt;=k[i];++j)x=rd(),vec[i].push_back(x);sum[i]=rd();<br />
    }<br />
    t=rd();<br />
    memset(num,-,sizeof(num));<br />
    for(int i=;i&lt;=t;++i){<br />
        x=rd();y=rd();num[x]=y;<br />
    }ll Ans=;<br />
    for(int i=;i&lt;=m;++i){<br />
        int q=;<br />
        ans=;<br />
        for(int j=;j&lt;k[i];++j)if(~num[vec[i][j]])p[++q]=num[vec[i][j]];<br />
        dfs(,,,q,k[i],sum[i]);<br />
        (Ans*=ans)%=mod;<br />
    }<br />
    cout&lt;&lt;Ans;<br />
    return ;<br />
}</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8er4mq1.html">写自己的Socket框架&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxpjk09.html">Java Web整合开发实战：基于Struts 2&plus;Hibernate&plus;Spring 目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okn4yp9.html">Listview和Gridview自定义分割线</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ve7xj8.html">poj 3660 Cow Contest（传递闭包 Floyd）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w3ykwq.html">&lbrack;转载&rsqb; I wish you enough</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v37rm8.html">groovy构建和解析xml文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok62059.html">Com编程入门&mdash;&mdash;什么是COM，如何使用COM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0kmwlq.html">集合框架-TreeSet</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjn2538.html">Http中的Get&sol;Post方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy13nedq.html">19 Handler 总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7jlj9.html">Git - git branch - 查看本地仓分支列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv14zlzq.html">java----代码打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2553nxq.html">终端&lpar;命令行&rpar;连接MySQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj4x5e9.html">jsp查询修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4wrdm9.html">ubuntu 使用dpkg手动安装deb包时发生循环依赖的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wgwzwq.html">一些值得收藏的MySQL知识链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllxrj0q.html">python 从外部获取传入的参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rxnlo9.html">Docker学习笔记之Copy on Write机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjwpk49.html">ubuntu  实用命令收集</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5jml7q.html">Java - ArrayList源码分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j1ee5g9.html">switch变种玩法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdlolj9.html">tomcat8&period;0部署启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o7lrk8.html">网络编程--使用TCP协议发送接收数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r5jm48.html">下拉框、下拉控件之Select2</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rde2j9.html">APP-SERVICE-SDK&colon;setStorageSync&colon;fail&semi;at page&sol;near&sol;pages&sol;shops&sol;shops page lifeCycleMethod onUnload function</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wjvjwq.html">java内部类 和外部类的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjm2m39.html">Linux基础学习（10）--Shell基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw5gjv9.html">python设计模式第二十天【迭代器模式】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvongz8.html">Delphi处理数据网格DBGrid的编辑框 获取还没有提交到数据集的字段文本</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r5wo08.html">待解决ava&period;lang&period;OutOfMemoryError&colon; PermGen space &Tab;at java&period;lang&period;ClassLoader&period;defineClass1&lpar;Native Method&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
